#<profile4xi profile = "02" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "dummyprocess4xi.py">
#<abstract4xi abstract = "provides class DummyProcess4Xi"/>
#<refer4xi reference = "__init__.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
#<note4xi note = "module locates in dummy subfolder"/>
# -------------------------------------------------------------------------------------------------
                       

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'DummyProcess4Xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import weakref
    import array
    import itertools
    from queue import Queue         
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing import TimeoutError, cpu_count
    from multiprocessing.dummy.connection import Pipe
except:
    pass
#"
#/>


# -------------------------------------------------------------------------------------------------
# Special Imports                          
# -------------------------------------------------------------------------------------------------
#<specialize4xi speciality = "
from threading import Lock, RLock, Semaphore, BoundedSemaphore
from threading import Event
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from sleep4xi import omega2sleep4xi
from print4xi import print4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
from time4xi import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global object                              
#<note4xi note = "these are NOT the same ones as global _current_process !"/>
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global current_dummy_process
#"
#/>


# -------------------------------------------------------------------------------------------------
# Settings
#<note4xi note = "these are NOT the same ones as global _current_process !"/>
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
current_dummy_process = threading.current_thread
current_dummy_process()._children = weakref.WeakKeyDictionary()
#"
#"/>



#
# =================================================================================================
#<class4xi class = "DummyProcess4Xi" base = "threading.Thread" child = "None" 
#   synopsis = "Dummy process"
#   usage = "threading simulates multiprocessing"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
class DummyProcess4Xi(threading.Thread):
    '''
    DummyProcess class is inherited from Threading 
    '''
    
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi exposure = "
    _exposed_ = ('start', 'sense', 'reason', 'ace')       
    #"
    #/>

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    is_alive = threading.Thread.is_alive
    get_name = threading.Thread.getName
    set_name = threading.Thread.setName
    is_daemon = threading.Thread.isDaemon
    set_daemon = threading.Thread.setDaemon
    #"
    #/>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initialization of DummyProcess4Xi">                            
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __init__(self, group=None, target=None, name=None, args=(), kwargs={}):
        
        global current_dummy_process        
        
        # -----------------------------------------------------------------------------------------    
        # Step 1/7: 
        # -----------------------------------------------------------------------------------------                 
        class2print = "DummyProcess4Xi"
        method2print = "__init__"
        
        message2print = "{(Step 1/7a) started" + "; init-of-DummyProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 02:07:01 01/14/13 Pacific Standard Time
        
        message2print = "{(Step 1/7b) passed" + "; group-passed-to-init-of-DummyProcess4Xi: " + str(group) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                               
        # None
        
        message2print = "{(Step 1/7c) passed" + "; target-passed-to-init-of-DummyProcess4Xi: " + str(target) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                               
        # <function f4xi at 0x0000000002E47D90>
        
        message2print = "{(Step 1/7d) passed" + "; name-passed-to-init-of-DummyProcess4Xi: " + str(name) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                               
        # None        
        
        message2print = "{(Step 1/7e) passed" + "; args-passed-to-init-of-DummyProcess4Xi: " + str(args) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                               
        # ()
        
        message2print = "{(Step 1/7f) passed" + "; kwargs-passed-to-init-of-DummyProcess4Xi: " + str(kwargs) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                               
        # {}               
        
        message2print = "{(Step 1/7g) borning" + "; dummyprocess2xi-of-DummyProcess4Xi-borning: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # 02:07:01 01/14/13 Pacific Standard Time             

        message2print = "{(Step 1/7h) inheriting" + "; threading-Thread-inheriting-by-dummyprocess2xi-of-DummyProcess4Xi: " + str(threading.Thread)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'threading.Thread'>
        
        message2print = "{(Step 1/7i) sharing" + "; is-alive-sharing-by-dummyprocess2xi-of-DummyProcess4Xi: " + str(DummyProcess4Xi.is_alive)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # <function Thread.is_alive at 0x0000000002BDC158>
        
        message2print = "{(Step 1/7j) sharing" + "; get-name-sharing-by-dummyprocess2xi-of-DummyProcess4Xi: " + str(DummyProcess4Xi.get_name)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # <function Thread.getName at 0x0000000002BDC400>
        
        message2print = "{(Step 1/7k) sharing" + "; set-name-sharing-by-dummyprocess2xi-of-DummyProcess4Xi: " + str(DummyProcess4Xi.set_name)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # <function Thread.setName at 0x0000000002BDC488>
        
        message2print = "{(Step 1/7l) sharing" + "; is-daemon-sharing-by-dummyprocess2xi-of-DummyProcess4Xi: " + str(DummyProcess4Xi.is_daemon)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # <function Thread.isDaemon at 0x0000000002BDC2F0>
        
        message2print = "{(Step 1/7m) sharing" + "; set_daemon-sharing-by-dummyprocess2xi-of-DummyProcess4Xi: " + str(DummyProcess4Xi.set_daemon)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # <function Thread.setDaemon at 0x0000000002BDC378>
                                                        
        # -----------------------------------------------------------------------------------------    
        # Step 2/7: 
        # -----------------------------------------------------------------------------------------                 
        ack2thread = False
        nack2thread = True
        
        message2print = "{(Step 2/7a) calling" + "; Thread-init-calling-by-init-of-DummyProcess4Xi: " + str(threading.Thread.__init__) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        # <function Thread.__init__ at 0x0000000002BDA950>               
        try:
            threading.Thread.__init__(self, group, target, name, args, kwargs)
            
           
            message2print = "{(Step 2/7b) performed" + "; Thread-init-performed-by-init-of-DummyProcess4Xi: " + str(threading.Thread.__init__) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # <function Thread.__init__ at 0x0000000002BDA950>
            
            ack2thread = True 
            
            message2print = "{set" + "; ack2thread-set-by-init-of-DummyProcess4Xi to: " + str(ack2thread)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            # True
                       
        
            omega2sleep4xi (class2print, method2print)               # give time to others
            
        except:
            message2print = "{(Step 2/7c) yielded" + "; nack2thread-yielded-by-init-of-DummyProcess4Xi: " + str(nack2thread)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
                             
        # -----------------------------------------------------------------------------------------    
        # Step 3/7: 
        # -----------------------------------------------------------------------------------------                 
        
        self._pid = None
        

        message2print = "{(Step 3/7) set" + "; dummyprocess2xi-pid-set-by-init-of-DummyProcess4Xi to: " + str(self._pid)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # None                
                        
        
        # -----------------------------------------------------------------------------------------    
        # Step 4/7: 
        # -----------------------------------------------------------------------------------------                 
        
        self._children = weakref.WeakKeyDictionary()
        

        message2print = "{(Step 4/7) set" + "; dummyprocess2xi-children-set-by-init-of-DummyProcess4Xi to: " + str(self._children)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                  
        # <WeakKeyDictionary at 48389368>
        
        # -----------------------------------------------------------------------------------------    
        # Step 5/7: 
        # -----------------------------------------------------------------------------------------                 
        
        self._start_called = False
        
        message2print = "{(Step 5/7) set" + "; dummyprocess2xi-start-called-set-by-init-of-DummyProcess4Xi to: " + str(self._start_called)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # False
                
        # -----------------------------------------------------------------------------------------    
        # Step 6/7: 
        # -----------------------------------------------------------------------------------------                 
        message2print = "{(Step 6/7a) calling; current_dummy_process: " + str(current_dummy_process)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <function current_thread at 0x0000000002BDC7B8>
        
        self._parent = current_dummy_process()
        
    
        message2print = "{(Step 6/7b) set" + "; dummyprocess2xi-parent-set-by-init-of-DummyProcess4Xi to: " + str(self._parent)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # <_MainThread(MainThread, started 1380)>
                
        # -----------------------------------------------------------------------------------------    
        # Step 7/7: 
        # -----------------------------------------------------------------------------------------

        message2print = "{(Step 7/7a) inherited" + "; threading-Thread-inherited-by-dummyprocess2xi-of-DummyProcess4Xi: " + str(threading.Thread)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'threading.Thread'>
                             
        message2print = "{(Step 7/7b) activated" + "; dummyprocess2xi-of-DummyProcess4Xi-activated: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # 02:07:01 01/14/13 Pacific Standard Time
        
        message2print = "{(Step 7/7c) shared" + "; is-alive-shared-by-dummyprocess2xi-of-DummyProcess4Xi: " + str(DummyProcess4Xi.is_alive)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # <function Thread.is_alive at 0x0000000002BDC158>
        
        message2print = "{(Step 7/7d) shared" + "; get-name-shared-by-dummyprocess2xi-of-DummyProcess4Xi: " + str(DummyProcess4Xi.get_name)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # <function Thread.getName at 0x0000000002BDC400>
        
        message2print = "{(Step 7/7e) shared" + "; set-name-shared-by-dummyprocess2xi-of-DummyProcess4Xi: " + str(DummyProcess4Xi.set_name)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # <function Thread.setName at 0x0000000002BDC488>
        
        message2print = "{(Step 7/7f) shared" + "; is-daemon-shared-by-dummyprocess2xi-of-DummyProcess4Xi: " + str(DummyProcess4Xi.is_daemon)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # <function Thread.isDaemon at 0x0000000002BDC2F0>
        
        message2print = "{(Step 7/7g) shared" + "; set-daemon-shared-by-dummyprocess2xi-of-DummyProcess4Xi: " + str(DummyProcess4Xi.set_daemon)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # <function Thread.setDaemon at 0x0000000002BDC378>               
        
        message2print = "{(Step 7/7h) returning; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # 02:07:01 01/14/13 Pacific Standard Time         
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "start" usage = "starting a DummyProcess4Xi object">                           
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def start(self):
        
        # -----------------------------------------------------------------------------------------    
        # (Step 1/6): 
        # -----------------------------------------------------------------------------------------      
        class2print = "DummyProcess4Xi"
        method2print = "start"        
        
 
        message2print = "{(Step 1/6) started" + "; start-of-DummyProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 02:07:01 01/14/13 Pacific Standard Time
                 
        # -----------------------------------------------------------------------------------------    
        # (Step 2/6): 
        # -----------------------------------------------------------------------------------------              
        ack2parent = False
        nack2parent = True
        
        if self._parent is current_dummy_process():
        
            message2print = "{(Step 2/6a) asserted" + "; dummyprocess2xi-parent-asserted-by-start-of-DummyProcess4Xi: " + str(self._parent) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # <_MainThread(MainThread, started 1380)>
            
            ack2parent = True 
            
            message2print = "{set" + "; ack2parent-set-by-start-of-DummyProcess4X to: " + str(ack2parent)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            # 02:07:01 01/14/13 Pacific Standard Time
                        
        else:
            message2print = "{(Step 2/6b) yielded" + "; nack2parent-yielded-by-start-of-DummyProcess4Xi: " + str(nack2parent)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------    
        # (Step 3/6): 
        # -----------------------------------------------------------------------------------------                      
        self._start_called = True
         
        message2print = "{(Step 3/6) set" + "; dummyprocess2xi-start-called-set-by-start-of-DummyProcess4Xi to: " + str(self._start_called)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # True                
                        
        # -----------------------------------------------------------------------------------------    
        # (Step 4/6): 
        # -----------------------------------------------------------------------------------------              
        self._parent._children[self]= None
        
          
        message2print = "{(Step 4/6) set" + "; dummyprocess2xi-parent-children-set-by-start-of-DummyProcess4Xi to: " + str(self._parent._children[self])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # None
        
        # -----------------------------------------------------------------------------------------    
        # (Step 5/6): 
        # -----------------------------------------------------------------------------------------              
        ack2start = False
        nack2start = True
        
        try:
            threading.Thread.start(self)
            
      
            message2print = "{(Step 5/6a) performed" + "; Thread-start-performed-by-start-of-DummyProcess4Xi: " + str(threading.Thread.start) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # <function Thread.start at 0x0000000002BDAAE8>
            
            ack2start = True
            
            message2print = "{set" + "; ack2start-set-by-start-of-DummyProcess4Xi to: " + str(ack2start)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            # True
                      
        except:
            message2print = "{(Step 5/6b) yielded" + "; nack2start-yielded-by-start-of-DummyProcess4Xi: " + str(nack2start)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
            
                                  
        # -----------------------------------------------------------------------------------------    
        # (Step 6/6): 
        # -----------------------------------------------------------------------------------------              
        message2print = "{(Step 6/6) returning" + "; start-of-DummyProcess4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 02:07:01 01/14/13 Pacific Standard Time                
                
                                        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "exitcode" usage = "exitcode of DummyProcess4Xi">                            
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @property
    def exitcode(self):

        message2print = "{started" + "; exitcode-of-DummyProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
    
        if self._start_called and not self.is_alive():
        
            message2print = "{(Step 1/1a) returning" + "; 0-returning-by-exitcode-of-DummyProcess4Xi: " + str(0) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)    
                                
            return 0
        else:
            message2print = "{(Step 1/1b) returning" + "; None-returning-by-exitcode-of-DummyProcess4Xi: " + str(None) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)    
          
        
            return None
    #</methodize4xi>
                                           
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense" usage = "senses DummyProcess4Xi objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        senses DummyProcess4Xi objects
        '''
        
        
        class2print = 'DummyProcess4Xi'
        method2print = 'sense'
        
        message2print = "{started" + "; sense-of-DummyProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; dummyprocess4xi-sensing-by-sense-of-DummyProcess4Xi: " + str(DummyProcess4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                      
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-DummyProcess4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['is-alive-of-dummyprocess2xi'] = DummyProcess4Xi.is_alive()
            kb2xi['name-of-dummyprocess2xi'] = DummyProcess4Xi.get_name()            
            kb2xi['is-daemon-of-dummyprocess2xi'] = DummyProcess4Xi.is_daemon()
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-DummyProcess4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
            
      
        message2print = "{sensed" + "; dummyprocess4xi-sensed-by-sense-of-DummyProcess4Xi: " + str(DummyProcess4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-DummyProcess4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                             
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason" usage = "reasons DummyProcess4Xi objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        reasons DummyProcess4Xi objects
        '''
            
        
        class2print = 'DummyProcess4Xi'
        method2print = 'reason'

        message2print = "{started" + "; reason-of-DummyProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; dummyprocess4xi-reasoning-by-reason-of-DummyProcess4Xi: " + str(DummyProcess4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-DummyProcess4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
        message2print = "{reasoned" + "; dummyprocess4xi-reasoned-by-reason-of-DummyProcess4Xi: " + str(DummyProcess4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-DummyProcess4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                  
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace" usage = "aces DummyProcess4Xi objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces DummyProcess4Xi objects 
        '''
               
        
        
        class2print = 'DummyProcess4Xi'
        method2print = 'ace'
        
        message2print = "{started" + "; ace-of-DummyProcess4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; dummyprocess4xi-acing-by-ace-of-DummyProcess4Xi: " + str(DummyProcess4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                  
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-DummyProcess4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; dummyprocess4xi-aced-by-ace-of-DummyProcess4Xi: " + str(DummyProcess4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-DummyProcess4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                           
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        #</methodize4xi>
                       
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# None
#"
#>
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of dummyprocess4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>



